/*

 +------------------------+
 |                        |
 | Mojodo Project         |
 | + pcap file            |
 |                        |
 +------------------------+

*/
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <pcap.h>
#include <netinet/ip_icmp.h>
#include <netinet/ip.h>
#include <libsock.h>
#include <signal.h>
void stoptrace(){
	printf("[ Err! ]  :\tSorry Timed Out\n");
	//break;
	exit(0);
}
int trace(char *srcip,char *dstip, char *dev,char *retip){
	char *pProt;
	char errbuf[PCAP_ERRBUF_SIZE];
	pcap_t *pcap_fd;
	struct bpf_program filter;
	bpf_u_int32 netmask;            /* The netmask of our sniffing device */
	bpf_u_int32 netaddr;            /* The Ip of our sniffing device */
	struct pcap_pkthdr pcap_hdr;    /* The header that pcap gives us */
	const u_char *pcap_pkt;         /* The actual packet */
	struct iphdr *ip; /* The IP header */
	struct icmphdr *icmp; /* The ICMP header */
	struct in_addr srcfd;
	int retValue=-1;
	char *pcap_device;
	int offset, datalink;
	struct ls_ip ip4;

	pcap_device = malloc(strlen(dev));

	strncpy(pcap_device, dev, strlen(dev));

	pProt=malloc(strlen("icmp"));

	sprintf(pProt,"icmp");
	//printf(pProt);
	if (pcap_lookupnet(pcap_device , &netaddr , &netmask , errbuf)==-1)
		{
		printf("(pcap_lookupnet) %s\n", errbuf);
		exit(0);
		}

	if ((pcap_fd=pcap_open_live(pcap_device, BUFSIZ, 1, 0, errbuf))==NULL)
		{
		printf("(pcap_open_live) %s\n", errbuf);
		exit(0);
		}

	pcap_compile(pcap_fd, &filter, pProt, 0, netaddr);

	pcap_setfilter(pcap_fd, &filter);

	memset(&ip4,0,sizeof(struct ls_ip));
	ip4.tos=0;
	ip4.frag_off=0x00;
	ip4.id=rand();
	ip4.ttl=1;

	//pcap_setnonblock(pcap_fd,0,errbuf);
	while(retValue==-1){
		ls_sendudp(&ip4,srcip,dstip,(int)(rand() % 65535),(int)(rand() % 65535),NODATA,0);
		signal(SIGALRM, stoptrace);
		alarm(30);
		pcap_pkt = pcap_next(pcap_fd, &pcap_hdr);
		alarm(0);
		switch(pcap_datalink(pcap_fd))
			{
			case DLT_EN10MB:
				offset = 14;
				break;
			case DLT_NULL:
			case DLT_PPP:
				offset = 4;
				break;
			case DLT_SLIP:
			case DLT_LINUX_SLL:
				offset = 16;
				break;
			case DLT_RAW:
				offset = 0;
				break;
			case DLT_SLIP_BSDOS:
			case DLT_PPP_BSDOS:
				offset = 24;
				break;
			case DLT_PPP_ETHER:
				printf("PPPoE Not Supported.\n");
				exit(-1);
			default:
				printf("unknown datalink type (%d)\n", datalink);
				exit(-1);
			}

		ip = (struct iphdr *) (pcap_pkt + offset);

		icmp = (struct icmphdr *) (pcap_pkt + sizeof(struct iphdr) + offset);
		memset(&srcfd,0,sizeof(struct in_addr));
		srcfd.s_addr=ip->saddr;
		inet_ntop(AF_INET,&srcfd,retip,16);
		if (icmp->type==11){ //hop! hop! hop!;
			printf("[ hop! ]  : \t%s\n",retip);
			ip4.ttl++;
		}
		else if ((icmp->type==3) && (icmp->code==1)){ //host unreachable;
			printf("[ fuck! ] : \t%s seems down \n",retip);
			ip4.ttl++;
		}
		else if ((icmp->type==3) && (icmp->code==3)){ // Bingo!
			printf("[ Bingo! ]: \t%s\n",retip);
			retValue=0;
			ip4.ttl++;
		}
	}
	pcap_close(pcap_fd);
	return(retValue);
}
